// jshint esversion: 6 
import * as THREE from 'three';

	// 3hc
	export function cavity_3hc(length=1500) {
		const threeHCSR = new THREE.Object3D();
		const dmaterial = new THREE.MeshLambertMaterial({color: 0xf0f0f0});
		const dmaterial2 = new THREE.MeshLambertMaterial({color: 0xffffff});
		const d1geometry = new THREE.CylinderGeometry(700, 700, length, 35);
		const d1mesh = new THREE.Mesh(d1geometry, dmaterial);
		threeHCSR.add(d1mesh);				
		threeHCSR.rotateX(Math.PI * 0.5);
		threeHCSR.rotatedX = true;	

		// left
		const lrgeometry = new THREE.CylinderGeometry(750, 750, 100, 65);
		const d2mesh = new THREE.Mesh(lrgeometry, dmaterial);
		d2mesh.position.set(0, -length/2-50, 0);
		threeHCSR.add(d2mesh);

		// right
		const d3mesh = new THREE.Mesh(lrgeometry, dmaterial);
		d3mesh.position.set(0, length/2+50, 0);
		threeHCSR.add(d3mesh);

		// up1
		const udgeometry = new THREE.CylinderGeometry(250, 250, 100, 25);
		const d4mesh = new THREE.Mesh(udgeometry, dmaterial);
		d4mesh.rotateX(Math.PI * 0.5);
		d4mesh.rotateY(Math.PI * 1);
		d4mesh.rotateZ(Math.PI * 1);
		d4mesh.position.set(0, -400 , -730);		
		threeHCSR.add(d4mesh);

		// up2
		const udgeometry2 = new THREE.CylinderGeometry(150, 150, 100, 25);
		const d5mesh = new THREE.Mesh(udgeometry2, dmaterial);
		d5mesh.rotateX(Math.PI * 0.5);
		d5mesh.rotateY(Math.PI * 1);
		d5mesh.rotateZ(Math.PI * 1);
		d5mesh.position.set(0, 400 , -730);		
		threeHCSR.add(d5mesh);

		// up1a
		const udgeometrya = new THREE.CylinderGeometry(200, 200, 250, 25);
		const d6mesh = new THREE.Mesh(udgeometrya, dmaterial);
		d6mesh.rotateX(Math.PI * 0.5);
		d6mesh.rotateY(Math.PI * 1);
		d6mesh.rotateZ(Math.PI * 1);
		d6mesh.position.set(0, -400 , -870);		
		threeHCSR.add(d6mesh);		
		
		// up1b
		const udgeometryb = new THREE.CylinderGeometry(250, 250, 100, 25);
		const d7mesh = new THREE.Mesh(udgeometryb, dmaterial);
		d7mesh.rotateX(Math.PI * 0.5);
		d7mesh.rotateY(Math.PI * 1);
		d7mesh.rotateZ(Math.PI * 1);
		d7mesh.position.set(0, -400 , -1000);		
		threeHCSR.add(d7mesh);	
		
		// up1c
		const udgeometryc = new THREE.CylinderGeometry(200, 200, 400, 25);
		const d8mesh = new THREE.Mesh(udgeometryc, dmaterial);
		d8mesh.rotateX(Math.PI * 0.5);
		d8mesh.rotateY(Math.PI * 1);
		d8mesh.rotateZ(Math.PI * 1);
		d8mesh.position.set(0, -400 , -1100);		
		threeHCSR.add(d8mesh);	
		
		// up2d
		const udgeometry2d = new THREE.CylinderGeometry(100, 100, 200, 25);
		const d9mesh = new THREE.Mesh(udgeometry2d, dmaterial);
		d9mesh.rotateX(Math.PI * 0.5);
		d9mesh.rotateY(Math.PI * 1);
		d9mesh.rotateZ(Math.PI * 1);
		d9mesh.position.set(0, 400 , -830);		
		threeHCSR.add(d9mesh);		

		// up2e
		const udgeometry2e = new THREE.CylinderGeometry(130, 130, 100, 25);
		const d10mesh = new THREE.Mesh(udgeometry2e, dmaterial);
		d10mesh.rotateX(Math.PI * 0.5);
		d10mesh.rotateY(Math.PI * 1);
		d10mesh.rotateZ(Math.PI * 1);
		d10mesh.position.set(0, 400 , -930);		
		threeHCSR.add(d10mesh);			
		
		
		//tubo1
		const tubegeometry1 = new THREE.CylinderGeometry(30, 30, 1100, 25);
		const d12mesh = new THREE.Mesh(tubegeometry1, dmaterial);
		d12mesh.rotateX(Math.PI * 0.5);
		d12mesh.rotateY(Math.PI * 0.5);
		d12mesh.rotateZ(Math.PI * 0.5);
		d12mesh.position.set(-430, -150 , -930);		
		threeHCSR.add(d12mesh);	
		
		//tubo2
		const tubegeometry2 = new THREE.CylinderGeometry(30, 30, 450, 25);
		const d13mesh = new THREE.Mesh(tubegeometry2, dmaterial);
		d13mesh.rotateX(Math.PI * 0.5);
		d13mesh.rotateY(Math.PI * 1);
		d13mesh.rotateZ(Math.PI * 0.5);
		d13mesh.position.set(-200, 400 , -930);		
		threeHCSR.add(d13mesh);			
		
		//sferacopritubo
		const sphereGeometry = new THREE.SphereGeometry(30, 30, 30);
		const d14mesh = new THREE.Mesh(sphereGeometry, dmaterial);
		d14mesh.position.set(-430, 400 , -930);		
		threeHCSR.add(d14mesh);			
		
		//up3
		const udgeometry2g = new THREE.CylinderGeometry(50, 50, 100, 25);
		const d15mesh = new THREE.Mesh(udgeometry2g, dmaterial);
		d15mesh.rotateX(Math.PI * 0.5);
		d15mesh.rotateY(Math.PI * 1);
		d15mesh.rotateZ(Math.PI * 1);
		d15mesh.position.set(0, 650 , -700);		
		threeHCSR.add(d15mesh);	
		
		
		//up3a
		const udgeometry2h = new THREE.CylinderGeometry(30, 30, 400, 25);
		const d16mesh = new THREE.Mesh(udgeometry2h, dmaterial);
		d16mesh.rotateX(Math.PI * 0.5);
		d16mesh.rotateY(Math.PI * 1);
		d16mesh.rotateZ(Math.PI * 1);
		d16mesh.position.set(0, 650 , -900);		
		threeHCSR.add(d16mesh);		
		
		//up3b
		const udgeometry2l = new THREE.CylinderGeometry(30, 30, 400, 25);
		const d17mesh = new THREE.Mesh(udgeometry2l, dmaterial);
		d17mesh.rotateX(Math.PI * 0.5);
		d17mesh.rotateY(Math.PI * 1);
		d17mesh.rotateZ(Math.PI * 1);
		d17mesh.position.set(0, 650 , -900);		
		threeHCSR.add(d16mesh);				
		
		//up3c
		const udgeometry2m = new THREE.CylinderGeometry(30, 30, 400, 25);
		const d18mesh = new THREE.Mesh(udgeometry2m, dmaterial);
		d18mesh.rotateX(Math.PI * 0.5);
		d18mesh.rotateY(Math.PI * 0.75);
		d18mesh.rotateZ(Math.PI * 1.5);
		d18mesh.position.set(-140, 790 , -1100);		
		threeHCSR.add(d18mesh);			
 
		//sferacopritubo laterale
		const sphereGeometry2 = new THREE.SphereGeometry(30, 30, 30);
		const d19mesh = new THREE.Mesh(sphereGeometry2, dmaterial);
		d19mesh.position.set(0, 650 , -1100);		
		threeHCSR.add(d19mesh);			
		
		//tubilaterali1
		const lateraltube1 = new THREE.CylinderGeometry(180, 180, 100, 25);
		const d20mesh = new THREE.Mesh(lateraltube1, dmaterial);
		d20mesh.rotateX(Math.PI * 0.5);
		d20mesh.rotateY(Math.PI * 1);
		d20mesh.rotateZ(Math.PI * 0.5);
		d20mesh.position.set(-700, -400 , 0);		
		threeHCSR.add(d20mesh);

		//tubilaterali1a
		const lateraltube1a = new THREE.CylinderGeometry(120, 120, 200, 25);
		const d21mesh = new THREE.Mesh(lateraltube1a, dmaterial);
		d21mesh.rotateX(Math.PI * 0.5);
		d21mesh.rotateY(Math.PI * 1);
		d21mesh.rotateZ(Math.PI * 0.5);
		d21mesh.position.set(-800, -400 , 0);		
		threeHCSR.add(d21mesh);		
		
		//cubo1
		const cube1 = new THREE.BoxGeometry(240, 240, 240);
		const d22mesh = new THREE.Mesh(cube1, dmaterial);
		d22mesh.position.set(-1000, -400 , 0);
		threeHCSR.add(d22mesh);	
		
		//cubo2 red
		const cube2 = new THREE.BoxGeometry(190, 190, 190);
		const cubematerial = new THREE.MeshLambertMaterial({color: 0xFF0000});
		const d23mesh = new THREE.Mesh(cube2, cubematerial);
		d23mesh.position.set(-1000, -400 , -50);
		threeHCSR.add(d23mesh);	
		
		//tubilaterali2a
		const lateraltube2a = new THREE.CylinderGeometry(140, 140, 200, 25);
		const d24mesh = new THREE.Mesh(lateraltube2a, dmaterial);
		d24mesh.rotateX(Math.PI * 0.5);
		d24mesh.rotateY(Math.PI * 1);
		d24mesh.rotateZ(Math.PI * 0.5);
		d24mesh.position.set(-650, 0 , 0);		
		threeHCSR.add(d24mesh);		
		
		//tubilaterali2b
		const lateraltube2b = new THREE.CylinderGeometry(180, 180, 50, 25);
		const d25mesh = new THREE.Mesh(lateraltube2b, dmaterial);
		d25mesh.rotateX(Math.PI * 0.5);
		d25mesh.rotateY(Math.PI * 1);
		d25mesh.rotateZ(Math.PI * 0.5);
		d25mesh.position.set(-770, 0 , 0);		
		threeHCSR.add(d25mesh);		
		
		//tubilaterali3a
		const lateraltube3a = new THREE.CylinderGeometry(180, 180, 110, 25);
		const d26mesh = new THREE.Mesh(lateraltube3a, dmaterial);
		d26mesh.rotateX(Math.PI * 0.5);
		d26mesh.rotateY(Math.PI * 1);
		d26mesh.rotateZ(Math.PI * 0.5);
		d26mesh.position.set(-680, 520 , -200);	
		threeHCSR.add(d26mesh);			
		
		//bulloni front
		const bulloni1 = new THREE.CylinderGeometry(10, 10, 10, 8);
		const d27mesh = new THREE.Mesh(bulloni1, dmaterial2);
		d27mesh.rotateX(Math.PI * 0.5);
		d27mesh.rotateY(Math.PI * 1);
		d27mesh.rotateZ(Math.PI * 0.5);
		d27mesh.position.set(-800,100,-120);
		const bolt = new THREE.Object3D();
		const bolts = new THREE.Object3D();
		bolt.add(d27mesh);	
		for (let i=-6; i<6; i++) {
			const bolt2 = bolt.clone();
			bolt2.rotateX(-Math.PI / 6*i);
			bolts.add(bolt2);
		}
		bolts.add(bolt);
		const bolts2 = bolts.clone();
		bolts2.position.set(60,520,-200);
		threeHCSR.add(bolts);	
		threeHCSR.add(bolts2);	
		return threeHCSR;
	}
