	import * as THREE from 'three';

	// vacuum chamber
	export function chamber(length=3000) {
		const chamberMaterial = new THREE.MeshLambertMaterial({color: 0xc0c0c0});
		const chamberGeometry = new THREE.CylinderGeometry(25 /*radiusTop*/, 25 /*radiusBottom*/, length /*height*/, 20 /*radialSegments*/, 2 /*heightSegments*/, false /*openEnded*/,0 /*thetaStart*/, Math.PI * 2 /*thetaLength*/);
		const chamberMesh = new THREE.Mesh(chamberGeometry, chamberMaterial);
		chamberMesh.rotateX(Math.PI * 0.5);
		chamberMesh.scale.setX(2);
		chamberMesh.rotatedX = true;
		return chamberMesh;
	}
